/*
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MM          MM
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MMM        MMM
 *          TT        HH          HH  OO          OO  MMMM      MMMM 
 *          TT        HH          HH  OO          OO  MM MM    MM MM
 *          TT        HH          HH  OO          OO  MM  MM  MM  MM 
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM   MMMM   MM
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM    MM    MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM 
 *
 *                      l'mulateur Thomson TO7-70
 *
 *  Copyright (C) 1996 Sylvain Huet, 1999-2002 Eric Botcazou.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 *  Module     : to7keys.h
 *  Version    : 1.5.5
 *  Cr par   : Eric Botcazou
 *  Modifi par: Eric Botcazou 06/10/2001
 *
 *  scancodes des touches passs par le handler d'Allegro 4.
 */


#ifndef TO7KEYS_H
#define TO7KEYS_H

# if 0 //LUDO:
#define KEY_A                 1
#define KEY_B                 2
#define KEY_C                 3
#define KEY_D                 4
#define KEY_E                 5
#define KEY_F                 6
#define KEY_G                 7
#define KEY_H                 8
#define KEY_I                 9
#define KEY_J                 10
#define KEY_K                 11
#define KEY_L                 12
#define KEY_M                 13
#define KEY_N                 14
#define KEY_O                 15
#define KEY_P                 16
#define KEY_Q                 17
#define KEY_R                 18
#define KEY_S                 19
#define KEY_T                 20
#define KEY_U                 21
#define KEY_V                 22
#define KEY_W                 23
#define KEY_X                 24
#define KEY_Y                 25
#define KEY_Z                 26
#define KEY_0                 27
#define KEY_1                 28
#define KEY_2                 29
#define KEY_3                 30
#define KEY_4                 31
#define KEY_5                 32
#define KEY_6                 33
#define KEY_7                 34
#define KEY_8                 35
#define KEY_9                 36
#define KEY_0_PAD             37
#define KEY_1_PAD             38
#define KEY_2_PAD             39
#define KEY_3_PAD             40
#define KEY_4_PAD             41
#define KEY_5_PAD             42
#define KEY_6_PAD             43
#define KEY_7_PAD             44
#define KEY_8_PAD             45
#define KEY_9_PAD             46
#define KEY_F1                47
#define KEY_F2                48
#define KEY_F3                49
#define KEY_F4                50
#define KEY_F5                51
#define KEY_F6                52
#define KEY_F7                53
#define KEY_F8                54
#define KEY_F9                55
#define KEY_F10               56
#define KEY_F11               57
#define KEY_F12               58
#define KEY_ESC               59
#define KEY_TILDE             60
#define KEY_MINUS             61
#define KEY_EQUALS            62
#define KEY_BACKSPACE         63
#define KEY_TAB               64
#define KEY_OPENBRACE         65
#define KEY_CLOSEBRACE        66
#define KEY_ENTER             67
#define KEY_COLON             68
#define KEY_QUOTE             69
#define KEY_BACKSLASH         70
#define KEY_BACKSLASH2        71
#define KEY_COMMA             72
#define KEY_STOP              73
#define KEY_SLASH             74
#define KEY_SPACE             75
#define KEY_INSERT            76
#define KEY_DEL               77
#define KEY_HOME              78
#define KEY_END               79
#define KEY_PGUP              80
#define KEY_PGDN              81
#define KEY_LEFT              82
#define KEY_RIGHT             83
#define KEY_UP                84
#define KEY_DOWN              85
#define KEY_SLASH_PAD         86
#define KEY_ASTERISK          87
#define KEY_MINUS_PAD         88
#define KEY_PLUS_PAD          89
#define KEY_DEL_PAD           90
#define KEY_ENTER_PAD         91
#define KEY_PRTSCR            92
#define KEY_PAUSE             93
#define KEY_ABNT_C1           94
#define KEY_YEN               95
#define KEY_KANA              96
#define KEY_CONVERT           97
#define KEY_NOCONVERT         98
#define KEY_AT                99
#define KEY_CIRCUMFLEX        100
#define KEY_COLON2            101
#define KEY_KANJI             102

#define KEY_MODIFIERS         103

#define KEY_LSHIFT            103
#define KEY_RSHIFT            104
#define KEY_LCONTROL          105
#define KEY_RCONTROL          106
#define KEY_ALT               107
#define KEY_ALTGR             108
#define KEY_LWIN              109
#define KEY_RWIN              110
#define KEY_MENU              111
#define KEY_SCRLOCK           112
#define KEY_NUMLOCK           113
#define KEY_CAPSLOCK          114

#define KEY_MAX               115
# else

 enum to7_keys_emum {

    TO7_KEY_1,           
    TO7_KEY_2,           
    TO7_KEY_3,           
    TO7_KEY_4,           
    TO7_KEY_5,           
    TO7_KEY_6,           
    TO7_KEY_7,           
    TO7_KEY_8,           
    TO7_KEY_9,           
    TO7_KEY_0,           
    TO7_KEY_MINUS,       
    TO7_KEY_PLUS,        
    TO7_KEY_ACCENT,      
    TO7_KEY_SLASH,       
    TO7_KEY_ASTERISK,    
    TO7_KEY_COMMA,       
    TO7_KEY_PERIOD,      
    TO7_KEY_AT,          

    TO7_KEY_EXCLAMATN,   
    TO7_KEY_DBLQUOTE,    
    TO7_KEY_HASH,        
    TO7_KEY_DOLLAR,      
    TO7_KEY_PERCENT,     
    TO7_KEY_AMPERSAND,   
    TO7_KEY_QUOTE,       
    TO7_KEY_LEFTPAREN,   
    TO7_KEY_RIGHTPAREN,  
    TO7_KEY_BACKQUOTE,   
    TO7_KEY_EQUAL,       
    TO7_KEY_SEMICOLON,   
    TO7_KEY_QUESTION,    
    TO7_KEY_COLON,       
    TO7_KEY_LESS,        
    TO7_KEY_GREATER,     
    TO7_KEY_POWER,       


    TO7_KEY_STOP,        
    TO7_KEY_CNT   ,      
    TO7_KEY_RAZ   ,      
    TO7_KEY_SHIFT_L,     
    TO7_KEY_SHIFT_R,     

    TO7_KEY_A,           
    TO7_KEY_B,           
    TO7_KEY_C,           
    TO7_KEY_D,           
    TO7_KEY_E,           
    TO7_KEY_F,           
    TO7_KEY_G,           
    TO7_KEY_H,           
    TO7_KEY_I,           
    TO7_KEY_J,           
    TO7_KEY_K,           
    TO7_KEY_L,           
    TO7_KEY_M,           
    TO7_KEY_N,           
    TO7_KEY_O,           
    TO7_KEY_P,           
    TO7_KEY_Q,           
    TO7_KEY_R,           
    TO7_KEY_S,           
    TO7_KEY_T,           
    TO7_KEY_U,           
    TO7_KEY_V,           
    TO7_KEY_W,           
    TO7_KEY_X,           
    TO7_KEY_Y,           
    TO7_KEY_Z,           

    TO7_KEY_SPACE,       
    TO7_KEY_RETURN,      
    TO7_KEY_TOP,         

    TO7_KEY_DEL   ,      
    TO7_KEY_INS   ,      

    TO7_KEY_CAPSLOCK,    

    TO7_KEY_LEFT,        
    TO7_KEY_UP,          
    TO7_KEY_RIGHT,       
    TO7_KEY_DOWN,        

    TO7_KEY_JOY_UP,      
    TO7_KEY_JOY_DOWN,    
    TO7_KEY_JOY_LEFT,    
    TO7_KEY_JOY_RIGHT,   

    TO7_KEY_JOY_FIRE1,   
    TO7_KEY_JOY_FIRE2,   

    TO7_MAX_KEY
  };
# endif

#endif
