/*
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MM          MM
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MMM        MMM
 *          TT        HH          HH  OO          OO  MMMM      MMMM 
 *          TT        HH          HH  OO          OO  MM MM    MM MM
 *          TT        HH          HH  OO          OO  MM  MM  MM  MM 
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM   MMMM   MM
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM    MM    MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM 
 *
 *                      l'mulateur Thomson TO7-70
 *
 *  Copyright (C) 1996 Sylvain Huet, 1999-2003 Eric Botcazou.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 *  Module     : linux/display.c
 *  Version    : 1.5.5
 *  Cr par   : Eric Botcazou juillet 1999
 *  Modifi par: Eric Botcazou 03/11/2003
 *
 *  Module d'interface avec le serveur X.
 */


#ifndef SCAN_DEPEND
   #include <stdio.h>
   #include <stdlib.h>
# if 0 //LUDO:
   #include <gdk/gdkx.h>
   #include <X11/Xlib.h>
   #include <X11/Xutil.h>
   #include <X11/keysym.h>
# endif
#endif

#include "to7.h"
#include "display.h"
#include "graphic.h"
#include "main.h"
#include "to7keys.h"


# if 0 //LUDO:
int screen;
Display *display;
int mit_shm_enabled;
Window main_win, screen_win;
int screen_size;
# endif
int mouse_x, mouse_y;

static Cursor null_cursor;
static int x11_to_alleg[256];

//LUDO:
ushort to7_vram[TO7_SCREEN_W * TO7_SCREEN_H];

# if 0 //LUDO:
#define KB_SIZE  100
static struct {
    int keysym;
    int keycode;
} keyconv[KB_SIZE]={ 	
      {XK_Escape, 		KEY_ESC},
			{XK_1, 			KEY_1  },
			{XK_2,			KEY_2  },
			{XK_3,	 		KEY_3  },
			{XK_4,	 		KEY_4  },
			{XK_5,	 		KEY_5  },
			{XK_6,	 		KEY_6  },
			{XK_7,	 		KEY_7  },
			{XK_8,			KEY_8  },
			{XK_9,			KEY_9  },
			{XK_0,	 		KEY_0  },
			{XK_parenright,		KEY_MINUS },
			{XK_equal, 		KEY_EQUALS },
			{XK_BackSpace, 		KEY_BACKSPACE },
			{XK_Tab, 		KEY_TAB },
			{XK_A,	 		KEY_Q },
			{XK_Z,	 		KEY_W },
			{XK_E,			KEY_E },
			{XK_R,			KEY_R },
			{XK_T,	 		KEY_T },
			{XK_Y,	 		KEY_Y },
			{XK_U,	 		KEY_U },
			{XK_I,	 		KEY_I },
			{XK_O, 			KEY_O },
			{XK_P, 			KEY_P },
			{XK_dead_circumflex,    KEY_OPENBRACE },
			{XK_dollar, 		KEY_CLOSEBRACE },
			{XK_Return, 		KEY_ENTER },
			{XK_Control_L, 		KEY_LCONTROL },
			{XK_Q,	 		KEY_A },
			{XK_S,	 		KEY_S },
			{XK_D,	 		KEY_D },
			{XK_F,	 		KEY_F },
			{XK_G,	 		KEY_G },
			{XK_H,			KEY_H },
			{XK_J, 			KEY_J },
			{XK_K, 			KEY_K },
			{XK_L,			KEY_L },
			{XK_M, 			KEY_COLON },
			{XK_percent, 		KEY_QUOTE },
			{XK_twosuperior, 	KEY_TILDE },
			{XK_Shift_L, 		KEY_LSHIFT },
			{XK_asterisk, 		KEY_ASTERISK },
			{XK_W, 			KEY_Z },
			{XK_X, 			KEY_X },
			{XK_C, 			KEY_C },
			{XK_V, 			KEY_V },
			{XK_B, 			KEY_B },
			{XK_N, 			KEY_N },
			{XK_comma, 		KEY_M },
			{XK_semicolon, 		KEY_COMMA },
			{XK_colon, 		KEY_STOP },
			{XK_exclam, 		KEY_SLASH },
			{XK_Shift_R, 		KEY_RSHIFT },
			{XK_KP_Multiply, 	KEY_ASTERISK },
			{XK_Alt_L, 		KEY_ALT },
			{XK_space, 		KEY_SPACE },
			{XK_Caps_Lock, 		KEY_CAPSLOCK },
			{XK_F1, 		KEY_F1 },
			{XK_F2, 		KEY_F2 },
			{XK_F3, 		KEY_F3 },
			{XK_F4, 		KEY_F4 },
			{XK_F5, 		KEY_F5 },
			{XK_F6, 		KEY_F6 },
			{XK_F7, 		KEY_F7 },
			{XK_F8, 		KEY_F8 },
			{XK_F9, 		KEY_F9 },
			{XK_F10, 		KEY_F10 },
			{XK_Num_Lock, 		KEY_NUMLOCK },
			{XK_Scroll_Lock, 	KEY_SCRLOCK },
			{XK_KP_7, 		KEY_7_PAD },
			{XK_KP_8, 		KEY_8_PAD },
			{XK_KP_9, 		KEY_9_PAD },
			{XK_KP_Subtract, 	KEY_MINUS_PAD },
			{XK_KP_4, 		KEY_4_PAD },
			{XK_KP_5, 		KEY_5_PAD },
			{XK_KP_6, 		KEY_6_PAD },
			{XK_KP_Add, 		KEY_PLUS_PAD },
			{XK_KP_1, 		KEY_1_PAD },
			{XK_KP_2, 		KEY_2_PAD },
			{XK_KP_3, 		KEY_3_PAD },
			{XK_KP_0, 		KEY_0_PAD },
			{XK_KP_Decimal, 	KEY_DEL_PAD },
			{XK_less, 		KEY_BACKSLASH2 },
			{XK_F11, 		KEY_F11 },
			{XK_F12, 		KEY_F12 },
			{XK_KP_Enter, 		KEY_ENTER_PAD },
			{XK_Control_R, 		KEY_RCONTROL },
			{XK_KP_Divide, 		KEY_SLASH_PAD },
			{XK_Mode_switch, 	KEY_ALTGR },
			{XK_Home, 		KEY_HOME },
			{XK_Up, 		KEY_UP },
			{XK_Page_Up, 		KEY_PGUP },
			{XK_Left, 		KEY_LEFT },
			{XK_Right, 		KEY_RIGHT },
			{XK_End, 		KEY_END },
			{XK_Down, 		KEY_DOWN },
			{XK_Page_Down, 		KEY_PGDN },
			{XK_Insert, 		KEY_INSERT },
			{XK_Delete, 		KEY_DEL } };
# endif


/* InitDisplay:
 *  Ouvre la connexion avec le serveur X et initialise le clavier.
 */
void InitDisplay(void)
{
# if 0 //LUDO:
    register int i;
    int ret1, ret2, ret3;

    /* Connexion au serveur X */
    display = GDK_DISPLAY();
    screen=DefaultScreen(display);

    /* Calcul de la table de conversion des keycodes */
    for (i=0; i<KB_SIZE; i++)
        x11_to_alleg[XKeysymToKeycode(display,keyconv[i].keysym)]=keyconv[i].keycode;

    /* Test de prsence de l'extension MIT-SHM */
    mit_shm_enabled=XQueryExtension(display, "MIT-SHM", &ret1, &ret2, &ret3);
# endif
}



/* InitWindow:
 *  Met en place les proprits et cre la fentre principale,
 *  calcule la position et cre la fentre de l'cran.
 */
void InitWindow(int argc, char *argv[], int x, int y, int user_flags)
{
# if 0 //LUDO:
    char *window_name="Thom - l'mulateur TO7-70";
    XSizeHints *size_hints;
    XWMHints *wm_hints;
    XClassHint *class_hints;
    XTextProperty windowName;
    XSetWindowAttributes win_attrb;
    Pixmap null_bitmap;
    XColor color;
        
    printf("Cration de la fentre principale...");

    if ( !(size_hints=XAllocSizeHints()) || !(wm_hints = XAllocWMHints()) ||
	                                  !(class_hints = XAllocClassHint()) )
    {
        fprintf(stderr,"erreur d'allocation mmoire X\n");
        exit(EXIT_FAILURE);
    }
    
    /* Cration de la fentre principale */
    main_win=XCreateSimpleWindow(display, RootWindow(display,screen), 
       x, y, WINDOW_WIDTH, WINDOW_HEIGHT, 4, WhitePixel(display, screen),
              BlackPixel(display,screen));

    XSelectInput(display,main_win,FocusChangeMask|KeyPressMask|KeyReleaseMask);

    /* Cration du curseur invisible */
    null_bitmap = XCreateBitmapFromData(display, main_win, "", 1, 1);
    null_cursor = XCreatePixmapCursor(display, null_bitmap, null_bitmap, &color, &color, 0, 0);
    XFreePixmap(display, null_bitmap);
    
    /* Cration de la fentre de l'cran */
    screen_win=XCreateSimpleWindow(display, main_win, BORDER_SIZE, BORDER_SIZE,
     SCREEN_WIDTH, SCREEN_HEIGHT, 0, BlackPixel(display, screen), BlackPixel(display,screen));

    win_attrb.event_mask=ExposureMask|ButtonPressMask|ButtonReleaseMask|PointerMotionMask;
    win_attrb.win_gravity=CenterGravity;    
    XChangeWindowAttributes(display, screen_win, CWWinGravity|CWEventMask, &win_attrb);

    /* Dimensionnement de la fentre */
    size_hints->min_width=WINDOW_WIDTH;
    size_hints->min_height=WINDOW_HEIGHT;
    size_hints->max_width=1280;
    size_hints->max_height=800;
    size_hints->flags=PPosition | PSize | PMinSize | PMaxSize | user_flags;
    
    /* Formatage du nom de la fentre */ 
    if (!XStringListToTextProperty(&window_name, 1, &windowName))
    {
        fprintf(stderr,"erreur d'allocation de structure X\n");
        exit(EXIT_FAILURE);
    }
		
    /* Renseignement du Window Manager */
    wm_hints->initial_state = NormalState;
    wm_hints->input = True;
    wm_hints->flags = StateHint | InputHint;

    class_hints->res_name=PROG_NAME;
    class_hints->res_class=PROG_CLASS;

    XSetWMProperties(display, main_win, &windowName, NULL, argv, argc,
       size_hints, wm_hints, class_hints);
       
    XMapWindow(display,screen_win);
    XMapWindow(display,main_win);

    printf("ok\n");
# endif
}



/* HandleEvents:
 *  Lit et traite les vnements envoys par le serveur X.
 */
void HandleEvents(void) 
{
  psp_update_keys();
# if 0 //LUDO:
    XEvent ev;
    static int need_modifiers_reset;
           int key;

    while (XPending(display))
    { 
        XNextEvent(display,&ev);

        switch (ev.type)
        {
	    case FocusIn:  /* main_win */
                to7_InputReset(0, 0);
		need_modifiers_reset=True;
		break;

	    case KeyRelease:  /* main_win */
                to7_HandleKeyPress(x11_to_alleg[ev.xkey.keycode], True);
                break;
              
	    case KeyPress:  /* main_win */
		if (need_modifiers_reset)
		{
		    int value = 0;

		    if (ev.xkey.state&ShiftMask)
			value |= TO7_SHIFT_FLAG;

		    if (ev.xkey.state&ControlMask)
			value |= TO7_CTRL_FLAG;

                    /* la led Caps Lock n'est pas supporte */		    

		    to7_InputReset(TO7_SHIFT_FLAG | TO7_CTRL_FLAG, value); 
		    need_modifiers_reset=False;
		}

                key=x11_to_alleg[ev.xkey.keycode];

                if (key==KEY_ESC)
                    thom.command=CONTROL_PANEL;
                else    
                    to7_HandleKeyPress(key, False);

                break;

	    case Expose:  /* screen_win */
		RetraceScreen(ev.xexpose.x, ev.xexpose.y, ev.xexpose.width, ev.xexpose.height);  

#ifdef DEBUG
		fprintf(stderr, "Expose event: x=%d, y=%d, w=%d, h=%d\n", ev.xexpose.x, ev.xexpose.y, ev.xexpose.width, ev.xexpose.height);
#endif     
                break;
                 
	    case ButtonRelease:  /* screen_win */
                if (ev.xbutton.button==Button1)
                    to7_HandleMouseClick(1, True);
                break;	

	    case ButtonPress:  /* screen_win */
                if (ev.xbutton.button==Button1)
                    to7_HandleMouseClick(1, False);
		else if (ev.xbutton.button==Button3)
		{
		    static int pointer_on=1;

		    pointer_on^=1;
		    XDefineCursor(display,main_win, pointer_on ? None : null_cursor);
		}
                break;

            case MotionNotify:  /* screen_win */
                to7_HandleMouseMotion(ev.xbutton.x/screen_size,ev.xbutton.y/screen_size);
                break;

        } /* end of switch(ev.type) */
    }  /* end of while (XPending) */
# endif
}
