/*
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MM          MM
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MMM        MMM
 *          TT        HH          HH  OO          OO  MMMM      MMMM 
 *          TT        HH          HH  OO          OO  MM MM    MM MM
 *          TT        HH          HH  OO          OO  MM  MM  MM  MM 
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM   MMMM   MM
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM    MM    MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM 
 *
 *                      l'mulateur Thomson TO7-70
 *
 *  Copyright (C) 1996 Sylvain Huet, 1999-2003 Eric Botcazou.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 *  Module     : linux/message.c
 *  Version    : 1.5.5
 *  Cr par   : Eric Botcazou juillet 1999
 *  Modifi par: Eric Botcazou 03/11/2003
 *
 *  Classe Message d'extension du toolkit GTK+ 1.2.x .
 */


#ifndef SCAN_DEPEND
# if 0 //LUDO:
   #include <gtk/gtkbutton.h>
   #include <gtk/gtkhbbox.h>
   #include <gtk/gtklabel.h>
   #include <gtk/gtksignal.h>
   #include <gtk/gtkvbox.h>
# endif
#endif

# if 0 //LUDO:
#include "message.h"
# endif



/* partie prive de la classe Message:
 */
static void message_class_init(MessageClass *class)
{
    (void) class;
}



static void message_init(Message *mesg)
{
    GtkWidget *vbox, *button_box, *button;

    mesg->window.type=GTK_WINDOW_DIALOG;
    gtk_window_set_title(&mesg->window, "Teo");
    gtk_window_set_position(&mesg->window, GTK_WIN_POS_CENTER);
    gtk_signal_connect_object( GTK_OBJECT(&mesg->window), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(mesg) );

    vbox=gtk_vbox_new(FALSE,5);
    gtk_container_set_border_width( GTK_CONTAINER(vbox), 10);
    gtk_container_add( GTK_CONTAINER(&mesg->window), vbox);
    gtk_widget_show(vbox);

    mesg->label=gtk_label_new("\0");
    gtk_box_pack_start( GTK_BOX(vbox), mesg->label, TRUE, FALSE, 0);
    gtk_widget_show(mesg->label);

    button_box=gtk_hbutton_box_new();
    gtk_box_pack_start( GTK_BOX(vbox), button_box, TRUE, FALSE, 0);
    gtk_widget_show(button_box);

    button=gtk_button_new_with_label("OK");
    gtk_container_add( GTK_CONTAINER(button_box), button);
    gtk_signal_connect_object( GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(mesg) );
    gtk_widget_show(button);
}



/* partie publique de la classe Message:
 */
guint message_get_type(void)
{
    static guint mesg_type = 0;

    if (!mesg_type)
    {
        GtkTypeInfo mesg_info={ "Message",
				sizeof(Message),
				sizeof(MessageClass),
				(GtkClassInitFunc) message_class_init,
				(GtkObjectInitFunc) message_init,
				NULL,
				NULL,
				(GtkClassInitFunc) NULL };

        mesg_type=gtk_type_unique(gtk_window_get_type(),&mesg_info);
    }

    return mesg_type;
}



GtkWidget *message_new(const gchar *label)
{
    Message *mesg=MESSAGE( gtk_type_new (message_get_type() ));

    gtk_label_set_text( GTK_LABEL(mesg->label), label);

    return GTK_WIDGET(mesg);
}
